const express = require('express');
const url = require('url');
const bodyParser = require("body-parser");
const portnumber = 2007;
const server = express();

 // server.use(express.static("."));
server.use(bodyParser.urlencoded({ extended: false, limit: '1mb' }));

server.post('/submit-message', submitMessagePost);
server.get('/index.html', displayMessages);
server.get('/', displayMessages);
server.listen(portnumber, function ()  {
    console.log('listening at port ' + portnumber);
});

function submitMessagePost(req, res) {
    console.log("submitMessagePost called");
    data = req.body; 
    newMessage = {}
    newMessage.username = data.username;
    newMessage.content = data.messageContent;
    newMessage.timestamp = (new Date()); 
    messageBoard.push (newMessage);
    htmlPage = constructPageFromData(newMessage.username);
    res.send(htmlPage);
}
function displayMessages (req, res) {
    htmlPage = constructPageFromData('');
    res.send(htmlPage);
}

function constructPageFromData(username) {
    var tableString  = '';
    for (let i = 0; i < messageBoard.length; i++) {
        let message = messageBoard[i];
        tableString += '<tr><td><div><strong>' + message.username + ' </strong>' + message.timestamp.toString() + '</div><div>' + message.content + '</div></td></tr>'
    }

    var htmlText = `
    <html>
    <head>
    <title>Public Pinboard</title>
    <link rel="stylesheet" href="https://maxcdn.bootstrapcdn.com/bootstrap/3.4.1/css/bootstrap.min.css">
    <style>
    body {
      background-color: cornsilk;
    }

    textarea {
      min-width: 80ch;
      min-height: 15ch;
    }
  </style>
    </head>
        <body><div class="container"><h3>Public Pinboard</h3>   
        <p>
          Beispiel für eine Anwendung, in der die Html-Seiten vollständig server-seitig generiert werden. 
          Der Browser ist einzig und allein dafür da, das empfangene Html anzuzeigen und 
          mithilfe des <code>&lt;form&gt;</code>-Elements bei Klick auf <code>Submit</code>
          einen POST-Request zu schicken.                 
        </p>     
        <table class="table table-striped table-bordered table-hover">
        ` + 
        tableString 
        + `       
    </table>
    <form action="submit-message" method="POST">
    <div class="form-group">
    <label for="username">Benutzername:</label>
    <input name="username" value="`
    + username + 
    `"><br>
    <textarea name="messageContent"></textarea>
  </div>
  <button type="submit" class="btn btn-default">Submit</button>
</form>
    </div></body></html>`;
    
        return htmlText;
}

messageBoard = [];
/* 
  each message looks like this:
  {
    username : "Dominik",
    timestamp : Date object,
    content : "his message"
  }
*/ 

